/* --------------------------------------------------------
   ASYQ[  vC[R[h
   ڕW߂ē

                                     2004/6/15
                                         S.Mio
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "game.h"


/* ----------------------------------------------------- */
/* s */
int movedir;    /* ڕW(ォE) */


/* ----------------------------------------------------- */
#define ATTR_EMPTY  0   /* }bv1}XԂ̒T */
#define ATTR_SEARCH 1
#define ATTR_CLOSE  2
#define ATTR_WALL   3
#define ATTR_GOAL   4
#define ATTR_START  5
#define ATTR_PATH   6

typedef struct node {
  t_pos pos;                /* ̏ꏊ                 */
  struct node *backnode;    /* Tn߂ꏊ           */
  int cost;                 /* backposƌ݈ʒũRXg  */
  int attr;                 /* ̒n_Tς݂ǂ */
  int move;                 /*                        */
} t_node;


/* TpL[ */
#define NODEQUE_LIMIT (400)
static t_node nodeque[NODEQUE_LIMIT];
static int nodeque_head;

/* Tn_W߂L[ */
#define SEARCHQUE_LIMIT (400)
static t_node *searchque[SEARCHQUE_LIMIT];
static int searchque_head;

/* Tς݂ǂۑ */
static char searchmap[MAP_WIDTH][MAP_HEIGHT];

/* 4𒲂ׂ邽߂̑΍W */
static t_pos difpos[] = {{0, -1}, {1,  0},  {0, 1}, {-1, 0},};


/* -------------------------------------------------------- */
/* Tς݃`FbNf[^ */
void init_searchmap(void)
{
    int x, y;

    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            searchmap[x][y] = 0;
        }
    }
}

/* łɒTƂݒ */
void set_searchmap(int x, int y)
{
    searchmap[x][y] = 1;
}

/* ǂݒ */
void setwall_searchmap(int x, int y)
{
    searchmap[x][y] = 2;
}

/* Tǂ */
int issearchmap(int x, int y)
{
    return searchmap[x][y];
}


/* -------------------------------------------------------- */
/* 2_Ԃ̋𑪂 */
int distance(int x, int y, int gx, int gy)
{
    int dx, dy, d;

    dx = abs(x - gx);
    dy = abs(y - gy);

    d = ((dx < dy) ? dx : dy) / 2;
    return  dx + dy - d;
}

/* RXgv */
int poscost(int x, int y, int gx, int gy)
{
    int cost;

    /* 2_Ԃ̋̂܂܃RXg */
    cost = distance(x, y, gx, gy);
    return cost;
}


/* -------------------------------------------------------- */
/* m[h𓾂 */
t_node *get_node(int x, int y, t_node *backnode)
{
    t_node *node;

    if (nodeque_head == NODEQUE_LIMIT)
        return NULL;
    
    node = &nodeque[nodeque_head];
    nodeque_head++;
    node->backnode = backnode;
    node->pos.x = x;
    node->pos.y = y;
    return node;
}


/* -------------------------------------------------------- */
/* L[ɒTǉ */
void que_push(t_node *node)
{
    t_node *tmpnode;
    int i, j;

    if (searchque_head >= SEARCHQUE_LIMIT)
        return;
    searchque[searchque_head] = node;
    searchque_head++;

    /* RXg̒ႢŃ\[gĂ */
    if (searchque_head <= 1)
        return;
    for (i = 0; i < searchque_head; i++) {
        for (j = 1; j < searchque_head - i; j++) {
            if (searchque[j - 1]->cost < searchque[j]->cost) {
                tmpnode = searchque[j - 1];
                searchque[j - 1] = searchque[j];
                searchque[j] = tmpnode;
            }
        }
    }
}

/* L[To  */
t_node *que_pop(void)
{
    if (searchque_head == 0)
        return NULL;
    searchque_head--;
    return searchque[searchque_head];
}

/* S[TāCX^[g̑ڂԂ */
int get_startmove(t_node *endnode)
{
    t_node *backnode = endnode;
    t_node *node;

    do {
        node = backnode;
        backnode = node->backnode;
    } while (backnode->attr != ATTR_START);
    return node->move;
}


/* -------------------------------------------------------- */
/* Ts */
int root_search(int startx, int starty, int goalx, int goaly)
{
    int i, checkx, checky, cost, checkcount;
    t_node *node, *newnode;
    
    /* X^[g̐ݒ */
    searchque_head = 0;
    nodeque_head = 0;
    node = get_node(startx, starty, NULL);
    node->cost = 10000;
    node->attr = ATTR_START;
    
    /* X^[gʒuL[ɓ */
    que_push(node);
    
    /* nodeS[ɍs܂Ń[v */
    do {
        /* ׂʒuL[o */
        node = que_pop();
        
        /* 4ׂ */
        checkcount = 0;
        for (i = 0; i < 4; i++) {
            checkx = node->pos.x + difpos[i].x;
            checky = node->pos.y + difpos[i].y;
            
            /* ͈̓`FbN */
            if ((checkx < 0) || (checkx >= MAP_WIDTH) || 
                (checky < 0) || (checky >= MAP_HEIGHT))
                continue;

            /* ǂ⒲ς݂炻̈ʒu͎gȂ */
            if (issearchmap(checkx, checky) != 0) 
                continue;

            /* S[甲 */
            if ((checkx == goalx) && (checky == goaly)) {
                newnode = get_node(checkx, checky, node);
                newnode->attr = ATTR_GOAL;
                node = newnode;
                break;
            }
            
            /* RXg𓾂 */
            cost = poscost(checkx, checky, goalx, goaly);
            
            /* ̈ʒuRXg牽Ȃ */
            if (node->cost < cost)
                continue;
            
            /* RXgɒuĎ̒ */
            newnode = get_node(checkx, checky, node);
            newnode->attr = ATTR_SEARCH;
            newnode->cost = cost;
            newnode->move = i;
            que_push(newnode);
            checkcount++;
        }
        /* 1͂𒲂ׂȂCセ̈ʒu͎gȂ */
        if ((!checkcount) && (node->attr == ATTR_SEARCH))
            node->attr = ATTR_CLOSE;
        if (node->attr == ATTR_EMPTY)
            node->attr = ATTR_SEARCH;
    } while(node->attr != ATTR_GOAL);
    return get_startmove(node);
}


/* ----------------------------------------------------- */
/* R[h */
void wizard_init(t_initinfo *item)
{
    strcpy(item->name, "player 1");
    item->pos.x = 5;
    item->pos.y = 5;
    
    movedir = 0;
}

/* ^[̍sI */
void wizard_turnselect(t_playerinfo *player, t_cmd *cmd, t_mapitem *mapitem)
{
    int movework, i, startx, starty;
    int goalx[] = {0, MAP_WIDTH - 1};
    int goaly[] = {0, MAP_HEIGHT - 1};

    /* S[ɂǂ蒅ړς */
    if ((player->pos.x == goalx[movedir]) && 
        (player->pos.y == goaly[movedir])) {
        movedir++;
        movedir %= 2;
    }
    printf("movedir: %d\n", movedir);

    /* S[֌𓾂 */
    startx = player->pos.x;
    starty = player->pos.y;
    init_searchmap();
    set_searchmap(startx, starty);
    for (i = 0; i < 4; i++) {
        if (player->movearea[i] == false)
            setwall_searchmap(startx + difpos[i].x, 
                              starty + difpos[i].y);
    }
    printf("search\n");
    movework = root_search(player->pos.x, player->pos.y, 
      goalx[movedir], goaly[movedir]);

    cmd->type = CMD_MOVE;
    cmd->move = movework;
}

/* s̎s */
void wizard_turnresult(t_playerinfo *player, t_result *result)
{
    if (result->type == CMD_TURNSKIP) {
        /* ̃^[̓XLbv */
        return;
    }
    
    if (result->type == CMD_MOVE) {
        if (result->iscmdexec) {
            /* sł */
        } else {
            /* słȂ */
        }
    }
    
    /* {Ȃǂݒ */
}
