/* -------------------------------------------------------------------
   ASYQ[  Q[

                                     2004/6/15
                                         S.Mio
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "game.h"


/* ------------------------------------------------------------------- */
t_mapitem map[MAP_WIDTH][MAP_HEIGHT];
t_mapitem mapwork;
int state, turncount;
t_playerinfo userplayer, vsplayer, playerwork;
t_initinfo playerinit, vsplayerinit;
t_cmd playercmd, vsplayercmd;
t_result playerresult, vsplayerresult;


/* ------------------------------------------------------------------- */
t_pos difpos[] = {{0, -1}, {1, 0}, {0, 1}, {-1, 0}};


/* ------------------------------------------------------------------- */
/* @̗vfw肵n_ɓ */
void map_newseed(int x, int y)
{
    int i, count, seed;

    count = rand() % (MAPSEED_LIMIT + 1);
    map[x][y].seedcount = count;
    
    for (i = 0; i < MAGICSEED_LIMIT; i++)
        map[x][y].magicseed_typecount[i] = 0;

    for (i = 0; i < count; i++) {
        seed = rand() % MAGICSEED_LIMIT;
        map[x][y].magicseed[i] = seed;
        map[x][y].magicseed_typecount[seed]++;
    }
}

/* }bv */
void map_init(void)
{
    int x, y;

    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            map_newseed(x, y);
            map[x][y].mapattr = MAPATTR_PATH;
            map[x][y].wallcount = 0;
            if (map[x][y].seedcount == 0) 
                map[x][y].seedcount = -(rand() % 5);
        }
    }
}

/* w肳ꂽ@̗vf菜 */
int map_removeseed(int x, int y, int seed, int count)
{
    int i, pos, removecount;

    if (map[x][y].seedcount <= 0)
        return 0;

    if ((seed < 0) || (seed >= MAGICSEED_LIMIT))
        return 0;

    if (map[x][y].magicseed_typecount[seed] < count) {
        count = map[x][y].magicseed_typecount[seed];
    }
    
    pos = 0;
    removecount = 0;
    for (i = 0; i < map[x][y].seedcount; i++) {
        if ((map[x][y].magicseed[i] == seed) &&
            (removecount < count)) {
            removecount++;
            map[x][y].magicseed_typecount[seed]--;
            continue;
        }
        map[x][y].magicseed[pos] = map[x][y].magicseed[i];
        pos++;
    }
    map[x][y].seedcount -= removecount;
    if (map[x][y].seedcount == 0)
        map[x][y].seedcount = -(rand() % 10);
    return count;
}

/* }bvɗvf */
void map_addseed(void)
{
    int x, y;

    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            if (map[x][y].seedcount == 0)
                map_newseed(x, y);
            if (map[x][y].seedcount < 0)
                map[x][y].seedcount++;
        }
    }
}

/* }bv1}X̗vfdestփRs[ */
void map_copyitem(int x, int y, t_mapitem *dest)
{
    int count, i;
    
    if (map[x][y].seedcount <= 0)
        return;

    memcpy(dest, &map[x][y], sizeof(t_mapitem));
}

/* x,y}bv͈͓̔ǂ */
int map_isarea(int x, int y)
{
    if (x < 0)
        return false;
    if (x >= MAP_WIDTH)
        return false;
    if (y < 0)
        return false;
    if (y >= MAP_HEIGHT)
        return false;
    return true;
}

/* ړł邩ǂ */
int map_ismove(int x, int y)
{
    if (map_isarea(x, y) == false)
        return false;

    if (map[x][y].mapattr != MAPATTR_PATH)
        return false;
    
    if ((userplayer.pos.x == x) && (userplayer.pos.y == y))
        return false;
    if ((vsplayer.pos.x == x) && (vsplayer.pos.y == y))
        return false;
    
    return true;
}

/* ړn_̐ݒ */
void map_setmovepos(t_playerinfo *player)
{
    int x, y, i;
    
    x = player->pos.x;
    y = player->pos.y;
    
    for (i = 0; i < MOVE_LIMIT; i++) {
        player->movearea[i] = map_ismove(x + difpos[i].x, y + difpos[i].y);
    }
}

/* mapinfo𓾂 */
void map_getmapinfo(int dir, int x, int y, t_mapinfo *mapinfo)
{
    if ((dir < 0) || (dir >= MOVE_LIMIT))
        return;
    if (map_isarea(x, y) == false)
        return;
    
    map_copyitem(x, y, &mapinfo->mapitem);
    
    mapinfo->isplayer = 0;
    if ((userplayer.pos.x == x) && (userplayer.pos.y == y)) {
        mapinfo->isplayer = ID_PLAYER;
    }
    if ((vsplayer.pos.x == x) && (vsplayer.pos.y == y)) {
        mapinfo->isplayer = ID_VSPLAYER;
    }
    
    mapinfo->dir = dir;
    mapinfo->pos.x = x;
    mapinfo->pos.y = y;
}


/* ------------------------------------------------------------------- */
/* @֘A */

/* vC[ɖ@̃RXg邩ǂ */
int game_ismagicseedcost(int seed, int cost, t_playerinfo *player)
{
    if ((seed < 0) || (seed >= MAGICSEED_LIMIT))
        return false;

    if (player->magicseed_typecount[seed] >= cost)
        return true;
    
    return false;
}

/* vC[疂@̃RXg */
int game_removeplayermagicseed(int seed, int cost, t_playerinfo *player)
{
    int i, pos, removecount;

    if ((seed < 0) || (seed >= MAGICSEED_LIMIT))
        return 0;

    removecount = 0;
    pos = 0;
    for (i = 0; i < player->seedcount; i++) {
        if ((player->magicseed[i] == seed) &&
            (removecount < cost)) {
            removecount++;
            player->magicseed_typecount[seed]--;
            continue;
        }
        player->magicseed[pos] = player->magicseed[i];
        pos++;
    }

    player->seedcount -= removecount;
    return removecount;
}

/* RXgɉ@̌ʂ̒l𓾂 */
int game_getmagicval(int seed, t_cmd *cmd)
{
    int magicval[MAGICSEED_LIMIT][2] = {
        {1,2}, {1,2}, {1,3}, {5,10}, {1,2}, 
    };
    int val = -1;
    
    if ((seed < 0) || (seed >= MAGICSEED_LIMIT))
        return 0;
    
    if (cmd->magiccost == 1)
        val = 0;
    else if (cmd->magiccost == 2)
        val = 1;
    if (val == -1)
        return 0;

    return magicval[seed][val];
}


/* ------------------------------------------------------------------- */
/* eR}h */
typedef void (*t_func)(t_playerinfo *player, t_cmd *cmd, t_result *result);

/* ړ */
void game_cmd_move(t_playerinfo *player, t_cmd *cmd, t_result *result)
{
    int x, y;

    if ((cmd->move < 0) || (cmd->move >= MOVE_LIMIT))
        return;

    x = player->pos.x;
    y = player->pos.y;
    x += difpos[cmd->move].x;
    y += difpos[cmd->move].y;
    if (map_ismove(x, y)) {
        result->iscmdexec = true;
        result->move = cmd->move;
        result->pos.x = x;
        result->pos.y = y;
        player->pos.x = x;
        player->pos.y = y;
        player->move = cmd->move;
        map_setmovepos(player);
    }
}

/* Uɂ铖蔻 */
int game_cmd_magic_hitcheck(int x, int y, int damage, t_result *result)
{
    int hitpos = result->hitcount;

    if ((userplayer.pos.x == x) && (userplayer.pos.y == y)) {
        if (userplayer.shieldcount == 0) {
            userplayer.damage += damage;
            result->iscmdexec = true;
            result->hitinfo[hitpos].pos.x = x;
            result->hitinfo[hitpos].pos.y = y;
            result->hitinfo[hitpos].type = HIT_PLAYER;
            result->hitcount++;
        }
    }

    if ((vsplayer.pos.x == x) && (vsplayer.pos.y == y)) {
        if (vsplayer.shieldcount == 0) {
            vsplayer.damage += damage;
            result->iscmdexec = true;
            result->hitinfo[hitpos].pos.x = x;
            result->hitinfo[hitpos].pos.y = y;
            result->hitinfo[hitpos].type = HIT_PLAYER;
            result->hitcount++;
        }
    }
    
    if (map[x][y].mapattr == MAPATTR_WALL) {
        result->iscmdexec = true;
        result->hitinfo[hitpos].pos.x = x;
        result->hitinfo[hitpos].pos.y = y;
        if (map[x][y].wallcount - damage <= 0) {
            map[x][y].mapattr = MAPATTR_PATH;
            map[x][y].wallcount = 0;
            result->hitinfo[hitpos].type = HIT_WALLCRASH;
            result->hitcount++;
        } else {
            map[x][y].wallcount -= damage;
            result->hitinfo[hitpos].type = HIT_WALL;
            result->hitcount++;
        }
    }
    return result->hitcount;
}

/* @:΁CU */
void game_cmd_magic_attack(t_playerinfo *player, t_cmd *cmd, t_result *result)
{
    int x, y, dx, dy, count, i, dir, area;
    
    x = cmd->pos.x;
    y = cmd->pos.y;

    if (map_isarea(x, y) == false)
        return;

    area = game_getmagicval(cmd->magictype, cmd);
    if (area == 0)
        return;
    
    if (!((player->pos.x == x) && (player->pos.y == y)))
        game_cmd_magic_hitcheck(x, y, 1, result);
    
    if (area > 1) {
        for (i = 0; i < area - 1; i++) {
            for (dir = 0; dir < MOVE_LIMIT; dir++) {
                dx = x + (difpos[dir].x * (i + 1));
                dy = y + (difpos[dir].y * (i + 1));
                if (map_isarea(dx, dy) == false)
                    continue;
                if ((player->pos.x == dx) && (player->pos.y == dy))
                    continue;
                game_cmd_magic_hitcheck(dx, dy, 1, result);
            }
        }
    }
}

/* @:C_[W */
void game_cmd_magic_water(t_playerinfo *player, t_cmd *cmd, t_result *result)
{
    int damage;

    damage = game_getmagicval(cmd->magictype, cmd);
    if (damage == 0)
        return;

    if (player->damage - damage < 0) {
        result->count = player->damage;
        player->damage = 0;
    } else {
        result->count = damage;
        player->damage -= damage;
    }
    result->iscmdexec = true;
}

/* @:؁Ch */
void game_cmd_magic_protect(t_playerinfo *player, t_cmd *cmd, t_result *result)
{
    int count;

    count = game_getmagicval(cmd->magictype, cmd);
    if (count == 0)
        return;

    player->shieldcount += count;
    result->count = player->shieldcount;
    result->iscmdexec = true;
}

/* @:Cׂ */
void game_cmd_magic_search(t_playerinfo *player, t_cmd *cmd, t_result *result)
{
    int i, searchstep, x, y, dx, dy, dir, count;
    
    searchstep = game_getmagicval(cmd->magictype, cmd);
    
    x = player->pos.x;
    y = player->pos.y;
    count = 0;
    dir = cmd->move;
    if ((dir < 0) || (dir >= MOVE_LIMIT))
        return;
    for (i = 0; i < searchstep; i++) {
        dx = x + (difpos[dir].x * (i + 1));
        dy = y + (difpos[dir].y * (i + 1));
        if (map_isarea(dx, dy) == false)
            break;
        map_getmapinfo(dir, dx, dy, &result->mapinfo[count]);
        count++;
    }
    result->count = count;
    result->move = dir;
    result->iscmdexec = true;
}

/* @:yCQ */
void game_cmd_magic_wall(t_playerinfo *player, t_cmd *cmd, t_result *result)
{
    int x, y, count;
    
    x = cmd->pos.x;
    y = cmd->pos.y;

    if (map_isarea(x, y) == false)
        return;

    count = game_getmagicval(cmd->magictype, cmd);
    if (count == 0)
        return;
    
    map[x][y].mapattr = MAPATTR_WALL;
    map[x][y].wallcount += count;
    result->count = map[x][y].wallcount;
    result->pos.x = x;
    result->pos.x = y;
    result->iscmdexec = true;
}

/* @ */
void game_cmd_magic(t_playerinfo *player, t_cmd *cmd, t_result *result)
{
    t_func functable[] = {
        game_cmd_magic_attack,
        game_cmd_magic_water,
        game_cmd_magic_protect,
        game_cmd_magic_search,
        game_cmd_magic_wall,
    };

    if ((cmd->magictype < MAGICSEED_LIMIT) && (cmd->magictype >= 0)) {
        /* RXg邩ǂ */
        if (!game_ismagicseedcost(cmd->type, cmd->magiccost, player))
            return;
        
        /* @̃R}hs */
        functable[cmd->magictype](player, cmd, result);

        if (result->iscmdexec)
            game_removeplayermagicseed(cmd->type, cmd->magiccost, player);
    }
}

/* @̗vf𓾂 */
void game_cmd_getseed(t_playerinfo *player, t_cmd *cmd, t_result *result)
{
    int resultcount, i, count;
    
    if (cmd->count + player->seedcount >= PLAYERSEED_LIMIT)
        cmd->count = PLAYERSEED_LIMIT - player->seedcount;

    resultcount = map_removeseed(player->pos.x, player->pos.y, cmd->magictype, cmd->count);
    if (resultcount) {
        for (i = 0; i < resultcount; i++) {
            player->magicseed[player->seedcount] = cmd->magictype;
            player->magicseed_typecount[cmd->magictype]++;
            player->seedcount++;
        }
        
        result->iscmdexec = true;
        result->magictype = cmd->magictype;
        result->count = resultcount;
        result->pos.x = player->pos.x;
        result->pos.y = player->pos.y;
    }
}

/* ͂𒲂ׂ */
/* ^[㉺Ȅ𓾂 */
void game_cmd_search(t_playerinfo *player, t_cmd *cmd, t_result *result)
{
    int i, searchstep, count, x, y, dx, dy, dir;

    if ((cmd->count < 0) || (cmd->count >= 5))
        return;
    searchstep = cmd->count;
    player->skipturn = searchstep;
    
    x = player->pos.x;
    y = player->pos.y;
    count = 0;
    for (i = 0; i < searchstep; i++) {
        for (dir = 0; dir < MOVE_LIMIT; dir++) {
            dx = x + (difpos[dir].x * (i + 1));
            dy = y + (difpos[dir].y * (i + 1));
            if (map_isarea(dx, dy) == false)
                continue;
            map_getmapinfo(dir, dx, dy, &result->mapinfo[count]);
            count++;
        }
    }
    result->count = count;
    result->iscmdexec = true;
}

void game_cmd(t_playerinfo *player, t_cmd *cmd, t_result *result)
{
    t_func functable[] = {
        game_cmd_move,
        game_cmd_magic,
        game_cmd_getseed,
        game_cmd_search,
    };

    result->type = cmd->type;
    result->iscmdexec = false;
    result->count = 0;
    result->hitcount = 0;
    if ((cmd->type < CMD_LIMIT) && (cmd->type >= 0))
        functable[cmd->type](player, cmd, result);
}


/* ------------------------------------------------------------------- */
/* vC[̍ŏ̏Ԃݒ */
void game_player_init(int playerno, t_playerinfo *player, t_initinfo *playerinit)
{
    int i;

    player->pos.x = playerinit->pos.x;
    player->pos.y = playerinit->pos.y;
    if (player->pos.x < 0)
        player->pos.x = 0;
    if (player->pos.y < 0)
        player->pos.y = 0;
    if (player->pos.x >= MAP_WIDTH / 2)
        player->pos.x = (MAP_WIDTH / 2) -1;
    if (player->pos.y >= MAP_HEIGHT)
        player->pos.y = MAP_HEIGHT -1;

    if (playerno == ID_VSPLAYER)
        player->pos.x += MAP_WIDTH / 2;
    player->damage = 0;
    player->shieldcount = 0;
    player->seedcount = 0;
    player->skipturn = 0;
    player->move = MOVE_DOWN;
    
    map_setmovepos(player);
}

/* vC[̃f[^Rs[ */
void game_player_copy(t_playerinfo *destplayer, t_playerinfo *srcplayer)
{
    memcpy(destplayer, srcplayer, sizeof(t_playerinfo));
}

/* ^[̍XV */
void game_nextturn(void)
{
    turncount++;
    map_addseed();
    
    if (userplayer.shieldcount != 0)
        userplayer.shieldcount--;

    if (vsplayer.shieldcount != 0)
        vsplayer.shieldcount--;
}


/* ------------------------------------------------------------------- */
/* Q[̏ */
void game_init(void)
{
    srand((unsigned int)time(NULL));
    state = STATE_GAMEINIT;
    map_init();
    
    userplayer.pos.x = 0;
    userplayer.pos.y = 0;
    userplayer.shieldcount = 0;
    userplayer.move = MOVE_DOWN;
    vsplayer.pos.x = 0;
    vsplayer.pos.y = 0;
    vsplayer.shieldcount = 0;
    vsplayer.move = MOVE_DOWN;
    
    turncount = 0;
}

/* }bv̓e */
t_mapitem *game_getmap(int x, int y)
{
    if (!map_isarea(x, y))
        return NULL;
    return &map[x][y];
}

/* vC[̓e */
t_playerinfo *game_getuserplayer(void)
{
    return &userplayer;
}

t_playerinfo *game_getvsplayer(void)
{
    return &vsplayer;
}

t_result *game_getuserplayer_result(void)
{
    return &playerresult;
}

t_result *game_getvsplayer_result(void)
{
    return &vsplayerresult;
}

char *game_getuserplayer_name(void)
{
    return playerinit.name;
}

char *game_getvsplayer_name(void)
{
    return vsplayerinit.name;
}

/* }bv̕ */
char *game_getmapstr(void)
{
    char *playerstr   = "@";
    char *vsplayerstr = "V";
    char *wall        = "#";
    char *path        = ".";
    char *nonseed     = " ";
    static char s[MAP_WIDTH * MAP_HEIGHT];
    int x, y, seed;
    
    s[0] = '\0';
    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            if ((userplayer.pos.x == x) && (userplayer.pos.y == y)) {
                strcat(s, playerstr);
            } else if ((vsplayer.pos.x == x) && (vsplayer.pos.y == y)) {
                strcat(s, vsplayerstr);
            } else if (map[x][y].mapattr == MAPATTR_WALL) {
                strcat(s, wall);
            } else if (map[x][y].seedcount <= 0) {
                strcat(s, nonseed);
            } else {
                strcat(s, path);
            }
        }
        strcat(s, "\n");
    }
    return s;
}

/* Q[̐is */
int game_state(void)
{
    return state;
}

/* ܂̃^[ */
int game_turncount(void)
{
    return turncount;
}

/* ǂ */
int game_winner(void)
{
    if (userplayer.damage >= 3)
        return ID_VSPLAYER;
    if (vsplayer.damage >= 3)
        return ID_PLAYER;

    if (turncount > 100) {
        if (userplayer.damage > vsplayer.damage)
            return ID_VSPLAYER;
        else if (userplayer.damage < vsplayer.damage)
            return ID_PLAYER;
    }

    return -1;
}

/* Q[Iǂ */
int game_isend(void)
{
    if (turncount > 100)
        return true;

    if (game_winner() != -1)
        return true;

    return false;
}

/* ̖O */
char *game_winnername(void)
{
    char *name = NULL;

    if (game_winner() == ID_PLAYER)
        name = playerinit.name;
    else if (game_winner() == ID_VSPLAYER)
        name = vsplayerinit.name;
    return name;
}

/* ̖O */
char *game_losername(void)
{
    char *name = NULL;

    if (game_winner() == ID_PLAYER)
        name = vsplayerinit.name;
    else if (game_winner() == ID_VSPLAYER)
        name = playerinit.name;
    return name;
}

/* ^[̎s */
int game_main(void)
{
    int backstate = state;

    switch (state) {
      case STATE_GAMEINIT:
        wizard_init(&playerinit);
        game_player_init(ID_PLAYER, &userplayer, &playerinit);
        state = STATE_GAMEINIT_VS;
        break;
      case STATE_GAMEINIT_VS:
        vs_wizard_init(&vsplayerinit);
        game_player_init(ID_VSPLAYER, &vsplayer, &vsplayerinit);
        turncount = 1;
        state = STATE_GAMEPLAY;
        break;
      case STATE_GAMEPLAY:
        userplayer.turn = turncount;
        if (userplayer.skipturn) {
            userplayer.skipturn--;
            playerresult.type = CMD_TURNSKIP;
            playerresult.iscmdexec = false;
        } else {
            map_setmovepos(&userplayer);
            map_copyitem(userplayer.pos.x, userplayer.pos.y, &mapwork);
            game_player_copy(&playerwork, &userplayer);
            wizard_turnselect(&playerwork, &playercmd, &mapwork);
            playerresult.type = playercmd.type;
        }
        state = STATE_GAMERESULT;
        break;
      case STATE_GAMERESULT:
        if (playerresult.type != CMD_TURNSKIP) {
            game_cmd(&userplayer, &playercmd, &playerresult);
            game_player_copy(&playerwork, &userplayer);
        }
        wizard_turnresult(&playerwork, &playerresult);
        state = STATE_GAMEPLAY_VS;
        break;
      case STATE_GAMEPLAY_VS:
        vsplayer.turn = turncount;
        if (vsplayer.skipturn) {
            vsplayer.skipturn--;
            playerresult.type = CMD_TURNSKIP;
            playerresult.iscmdexec = false;
        } else {
            map_setmovepos(&vsplayer);
            map_copyitem(vsplayer.pos.x, vsplayer.pos.y, &mapwork);
            game_player_copy(&playerwork, &vsplayer);
            vs_wizard_turnselect(&playerwork, &vsplayercmd, &mapwork);
            playerresult.type = vsplayercmd.type;
        }
        state = STATE_GAMERESULT_VS;
        break;
      case STATE_GAMERESULT_VS:
        if (playerresult.type != CMD_TURNSKIP) {
            game_cmd(&vsplayer, &vsplayercmd, &vsplayerresult);
            game_player_copy(&playerwork, &vsplayer);
        }
        vs_wizard_turnresult(&playerwork, &vsplayerresult);
        state = STATE_GAMERNEXTTURN;
        break;
      case STATE_GAMERNEXTTURN:
        game_nextturn();
        state = STATE_GAMEPLAY;
        break;
      case STATE_GAMEEND:
        break;
    }
    return backstate;
}
