/* -------------------------------------------------------------------
   ASYQ[  WindowspQ[s{

                                     2004/7/15
                                         S.Mio
*/

#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include "gamemain.h"
#include "game.h"
#include "mainrc.h"


/* ------------------------------------------------------------------- */
static char szAppName[] = "AlgoGame";
static char szMainClass[] = "AlgoGameClass";
HINSTANCE hInstance;
int isgameend = false;


/* ------------------------------------------------------------------- */
/* pX֘A */
char executeDir[_MAX_PATH];
char *resouceDir = "res\\";

/* vO̎spX𓾂 */
char *setExecuteDir(char *srcfilename)
{
    TCHAR drive[_MAX_DRIVE];
    TCHAR dir[_MAX_DIR];
    TCHAR fname[_MAX_FNAME];
    TCHAR ext[_MAX_EXT];
    
    _splitpath(srcfilename, drive, dir, fname, ext);
    sprintf(executeDir, "%s%s", drive, dir);
    return executeDir;
}

/* rbg}bṽpX */
char *makeBitmapPath(char *filename)
{
    static char path[_MAX_PATH];

    sprintf(path, "%s%s%s", executeDir, resouceDir, filename);
    return path;
}


/* ------------------------------------------------------------------- */
/* `֘A */
#define PARTS_WIDTH   (32)
#define PARTS_HEIGHT  (32)

HBITMAP hBackBitmap;
HBITMAP hMapPartsBitmap;
HBITMAP hMapPartsMask;
HBITMAP hPlayer1Bitmap;
HBITMAP hPlayer1Mask;
HBITMAP hPlayer2Bitmap;
HBITMAP hPlayer2Mask;
HDC hBackDC;

HBITMAP readBitmap(char *filename)
{
    FILE *fp;
    char *path;
    BITMAPFILEHEADER bmpFileHeader;
    BITMAPINFO *bmpInfo;
    HBITMAP hBitmap;
    BYTE *pixelBits;
    int bmpInfoSize;
    
    path = makeBitmapPath(filename);
    fp = fopen(path, "rb");
    if (fp == NULL)
        return NULL;

    fread(&bmpFileHeader, sizeof(BITMAPFILEHEADER), 1, fp);
    if (bmpFileHeader.bfType != 0x4D42) {
        return NULL;
    }

    bmpInfoSize = bmpFileHeader.bfOffBits - sizeof(BITMAPFILEHEADER);
    bmpInfo = (BITMAPINFO *)malloc(bmpInfoSize);
    fread(bmpInfo, bmpInfoSize, 1, fp);

    hBitmap = CreateDIBSection(
        NULL, bmpInfo, DIB_RGB_COLORS, &pixelBits, NULL, 0);
    fread(pixelBits, bmpFileHeader.bfSize - bmpFileHeader.bfOffBits, 1, fp);
    fclose(fp);
    return hBitmap;
}

HBITMAP createMask(HDC hdc, HBITMAP hBitmap)
{
    HBITMAP hMaskBitmap;
    BITMAP bitmap;
    HDC maskDC, bitmapDC;
    int width, height;
    COLORREF colorref;
    
    GetObject(hBitmap, sizeof(BITMAP), &bitmap);
    width  = bitmap.bmWidth;
    height = bitmap.bmHeight;
    DeleteObject(&bitmap);

    maskDC      = CreateCompatibleDC(hdc);
    hMaskBitmap = CreateBitmap(width, height, 1, 1, NULL);
    SelectObject(maskDC, hMaskBitmap);

    bitmapDC    = CreateCompatibleDC(hdc);
    SelectObject(bitmapDC, hBitmap);
    colorref = SetBkColor(bitmapDC, RGB(0xff, 0, 0xff));

    BitBlt(maskDC, 0, 0, width, height, bitmapDC, 0, 0, SRCCOPY);

    SetBkColor(bitmapDC, colorref);
    BitBlt(bitmapDC, 0, 0, width, height, maskDC, 0, 0, 0x00220326);

    DeleteDC(maskDC);
    DeleteDC(bitmapDC);
    return hMaskBitmap;
}

void initGraphic(HDC hdc)
{
    hBackBitmap = CreateCompatibleBitmap(hdc, MAP_WIDTH * PARTS_WIDTH, MAP_HEIGHT * PARTS_HEIGHT);
    hBackDC = CreateCompatibleDC(hdc);

    SelectObject(hBackDC, hBackBitmap);
    PatBlt(hBackDC, 0, 0, MAP_WIDTH * PARTS_WIDTH, MAP_HEIGHT * PARTS_HEIGHT, WHITENESS);
}

void releaseGraphic(void)
{
    DeleteDC(hBackDC);
    DeleteObject(hBackBitmap);
}


/* ------------------------------------------------------------------- */
/* }bv` */
char map_attr[MAP_WIDTH][MAP_HEIGHT];

void mapAttrMake(void)
{
    int x, y;

    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            if (rand() % 2 == 0) {
                map_attr[x][y] = 1;
            } else {
                map_attr[x][y] = 0;
            }
        }
    }
}

void mapDraw(HDC hdc)
{
    HDC hdcParts;
    t_mapitem *mapitem;
    int x, y, sx, sy;
    
    hdcParts = CreateCompatibleDC(hdc);
    SelectObject(hdcParts, hMapPartsBitmap);
    
    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            mapitem = game_getmap(x, y);
            sy = 0;
            if (mapitem->seedcount > 0) {
                sx = 0;
            } else {
                sx = PARTS_WIDTH * 3;
            }
            if (mapitem->mapattr == MAPATTR_WALL) {
                sx += PARTS_WIDTH * 2;
            } else if (map_attr[x][y]) {
                sx += PARTS_WIDTH;
            }
            BitBlt(hBackDC, x * PARTS_WIDTH, y * PARTS_WIDTH, 
              PARTS_WIDTH, PARTS_HEIGHT, hdcParts, 
              sx, sy, SRCCOPY);
        }
    }

    DeleteDC(hdcParts);
}

/* LN^` */
void charaDraw(HDC hdc)
{
    HDC hdcParts, hdcPartsMask;
    t_playerinfo *player;
    int sxtable[] = {2, 3, 0, 1};
    int sx;
    
    hdcParts = CreateCompatibleDC(hdc);
    SelectObject(hdcParts, hPlayer1Bitmap);
    hdcPartsMask = CreateCompatibleDC(hdc);
    SelectObject(hdcPartsMask, hPlayer1Mask);
    player = game_getuserplayer();
    sx = sxtable[player->move] * PARTS_WIDTH;
    BitBlt(hBackDC, player->pos.x * PARTS_WIDTH, player->pos.y * PARTS_WIDTH, 
      PARTS_WIDTH, PARTS_HEIGHT, 
      hdcPartsMask, 
      sx, 0, SRCAND);
    BitBlt(hBackDC, player->pos.x * PARTS_WIDTH, player->pos.y * PARTS_WIDTH, 
      PARTS_WIDTH, PARTS_HEIGHT, 
      hdcParts, 
      sx, 0, SRCPAINT);

    SelectObject(hdcParts, hPlayer2Bitmap);
    SelectObject(hdcPartsMask, hPlayer2Mask);
    player = game_getvsplayer();
    sx = sxtable[player->move] * PARTS_WIDTH;
    BitBlt(hBackDC, player->pos.x * PARTS_WIDTH, player->pos.y * PARTS_WIDTH, 
      PARTS_WIDTH, PARTS_HEIGHT, 
      hdcPartsMask, 
      sx, 0, SRCAND);
    BitBlt(hBackDC, player->pos.x * PARTS_WIDTH, player->pos.y * PARTS_WIDTH, 
      PARTS_WIDTH, PARTS_HEIGHT, 
      hdcParts, 
      sx, 0, SRCPAINT);

    DeleteDC(hdcPartsMask);
    DeleteDC(hdcParts);
}

/* ʂ̕` */
void effectDraw(HDC hdc)
{
    /* ɂĎ */
}


/* ------------------------------------------------------------------- */
/* O */
HWND hEdit;
char buf[1024*64] = "\0";

void makeLogview(HWND hwnd)
{
    RECT rc;
    GetClientRect(hwnd, &rc);
    hEdit = CreateWindow("EDIT", NULL, 
      WS_CHILD | WS_VISIBLE | ES_WANTRETURN | ES_MULTILINE | ES_AUTOVSCROLL | WS_VSCROLL, 
      0, rc.bottom - 100 + 4, rc.right, 100 - 4,
      hwnd, NULL, hInstance, NULL);
    SendMessage(hEdit, EM_SETLIMITTEXT, (WPARAM)1024*64, 0);
}

void printLogview(char *s)
{
    strcat(buf, s);
    SetWindowText(hEdit, buf);
    SendMessage(hEdit, EM_SETSEL, strlen(buf), strlen(buf));
    SendMessage(hEdit, EM_SCROLLCARET, 0, 0);
}

void printlnLogview(char *s)
{
    printLogview(s);
    printLogview("\r\n");
}


/* ------------------------------------------------------------------- */
char *cmdname[] = {
    "ړ", "@", "@̎𓾂", "͂𒲂ׂ", "x",
};
char *movename[] = {
    "", "", "", "E", 
};
char *magicname[] = {
    "", "", "", "", "y",
};

void magicstring(char *buf, t_result *result)
{
    switch(result->magictype) {
      case MAGICSEED_FIRE:
        sprintf(buf, "  %sFu%svōU(%d-%dC:%d) ", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->pos.x,
          result->pos.y,
          result->count);
        break;
      case MAGICSEED_WATER:
        sprintf(buf, "  %sFu%svŉ (񕜓x:%d) ", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->count);
        break;
      case MAGICSEED_WOOD:
        sprintf(buf, "  %sFu%svŖh (x:%d) ", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->count);
        break;
      case MAGICSEED_WIND:
        sprintf(buf, "  %sFu%svŒׂ (%d-%d%dԂ%s) ", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->pos.x,
          result->pos.y,
          result->count,
          movename[result->move]);
        break;
      case MAGICSEED_EARTH:
        sprintf(buf, "  %sFu%svŕǂ쐬 (%d-%dCx:%d) ", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->pos.x,
          result->pos.y,
          result->count);
        break;
    }
}

void cmdstring(char *buf, t_result *result)
{
    if (result->type == CMD_TURNSKIP) {
        strcpy(buf, cmdname[CMD_LIMIT]);
        return;
    }
    if (result->iscmdexec == false) {
        sprintf(buf, "  %sFs", 
          cmdname[result->type]);
        return;
    }

    switch(result->type) {
      case CMD_MOVE:
        sprintf(buf, "  %sF%s (%d-%d)", 
          cmdname[result->type], 
          movename[result->move],
          result->pos.x,
          result->pos.y);
        break;
      case CMD_MAGIC:
        magicstring(buf, result);
        break;
      case CMD_GETSEED:
        sprintf(buf, "  %sF%s %s (%d-%d)", 
          cmdname[result->type], 
          magicname[result->magictype],
          result->count,
          result->pos.x,
          result->pos.y);
        break;
      case CMD_SEARCH:
        sprintf(buf, "  %sF%d}XԂ", 
          cmdname[result->type], 
          result->count);
        break;
    }
}

void printstate(int state)
{
    char buf[256];

    if (game_isend()) {
        printlnLogview("\r\nQ[II");
        
        if (game_winner() == -1) {
            printlnLogview("");
        } else {
            sprintf(buf, ": %s", game_winnername());
            printlnLogview(buf);
            sprintf(buf, ": %s", game_losername());
            printlnLogview(buf);
        }
        isgameend = true;
        return;
    }

    switch(state) {
      case STATE_GAMEPLAY:
        sprintf(buf, "u%sv̔", game_getuserplayer_name());
        printlnLogview(buf);
        break;
      case STATE_GAMERESULT:
        cmdstring(buf, game_getuserplayer_result());
        printlnLogview(buf);
        break;
      case STATE_GAMEPLAY_VS:
        sprintf(buf, "u%sv̔", game_getvsplayer_name());
        printlnLogview(buf);
        break;
      case STATE_GAMERESULT_VS:
        cmdstring(buf, game_getvsplayer_result());
        printlnLogview(buf);
        break;
      case STATE_GAMERNEXTTURN:
        sprintf(buf, "\r\n%d^[", game_turncount());
        printlnLogview(buf);
        break;
    }
}


/* ------------------------------------------------------------------- */
/* Q[s֘A */
void gamestart(void)
{
    game_init();
    mapAttrMake();
    isgameend = false;
}


/* ------------------------------------------------------------------- */
/* [v */
DWORD freqcount = 0;
DWORD gamecount = 0;

void DoIdle(HWND hwnd)
{
    HDC hdc;
    static int state = 0;

    if (GetTickCount() < freqcount + 50)
        return;
    freqcount = GetTickCount();

    hdc = GetDC(hwnd);
    mapDraw(hdc);

    if (gamecount == 0) {
        if (isgameend == false) {
            state = game_main();
            printstate(state);
            gamecount = 6;
        }
    } else {
        gamecount--;
    }

    if (state >= STATE_GAMEPLAY) {
        charaDraw(hdc);
        effectDraw(hdc);
    }

    BitBlt(hdc, 0, 0, MAP_WIDTH * PARTS_WIDTH, MAP_HEIGHT * PARTS_HEIGHT, hBackDC, 0, 0, SRCCOPY);
    ReleaseDC(hwnd, hdc);
}


/* ------------------------------------------------------------------- */
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    HDC hdc;
    PAINTSTRUCT ps;

    switch(msg) {
      case WM_CREATE:
        hdc = GetDC(hwnd);
        initGraphic(hdc);
        makeLogview(hwnd);
        printlnLogview("Q[Jn!\r\n");
        hMapPartsBitmap = readBitmap("game.bmp");
        hPlayer1Bitmap  = readBitmap("player1.bmp");
        hPlayer2Bitmap  = readBitmap("player2.bmp");

        hMapPartsMask = createMask(hdc, hMapPartsBitmap);
        hPlayer1Mask = createMask(hdc, hPlayer1Bitmap);
        hPlayer2Mask = createMask(hdc, hPlayer2Bitmap);
        
        ReleaseDC(hwnd, hdc);
        UpdateWindow(hwnd);
        return 0;
      case WM_PAINT:
        hdc = BeginPaint(hwnd, &ps);
        BitBlt(hdc, 0, 0, MAP_WIDTH * PARTS_WIDTH, MAP_HEIGHT * PARTS_HEIGHT, hBackDC, 0, 0, SRCCOPY);
        EndPaint(hwnd, &ps);
        return 0;
      case WM_DESTROY:
        releaseGraphic();
        PostQuitMessage(0);
        return 0;
      case WM_COMMAND:
        switch (LOWORD(wParam)) { 
          case IDM_END:
            SendMessage(hwnd, WM_CLOSE, 0, 0);
            break;
        }
        break; 
    }
    return DefWindowProc(hwnd, msg, wParam, lParam);
}


/* ------------------------------------------------------------------- */
int APIENTRY WinMain(HINSTANCE hCurrentInstance, 
  HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
    HWND hwnd;
    MSG msg;
    WNDCLASS wc;

    setExecuteDir(lpszCmdLine);
    hInstance = hCurrentInstance;

    gamestart();

    if (!hPrevInstance) {
        wc.style            = CS_HREDRAW | CS_VREDRAW; 
        wc.lpfnWndProc      = WndProc;
        wc.cbClsExtra       = 0;
        wc.cbWndExtra       = 0;
        wc.hInstance        = hInstance;
        wc.hIcon            = LoadIcon(hInstance, "IDI_ICON1");
        wc.hCursor          = LoadCursor(NULL, IDC_ARROW);
        wc.hbrBackground    = (HBRUSH)GetStockObject(BLACK_BRUSH);
        wc.lpszMenuName     = "MAINMENU";
        wc.lpszClassName    = szMainClass;
        RegisterClass(&wc);
    }
    hwnd = CreateWindow(
                szMainClass,
                szAppName,
                WS_OVERLAPPEDWINDOW,
                CW_USEDEFAULT,
                CW_USEDEFAULT,
                MAP_WIDTH * PARTS_WIDTH + GetSystemMetrics(SM_CXDLGFRAME) * 2,
                MAP_HEIGHT * PARTS_HEIGHT + 100
                    + GetSystemMetrics(SM_CYCAPTION)
                    + GetSystemMetrics(SM_CYMENU)
                    + GetSystemMetrics(SM_CYDLGFRAME) * 2,
                NULL,
                NULL,
                hInstance,
                NULL);

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);

    //C[v
    for (;;) {
        if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
            if(msg.message == WM_QUIT)
                break;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        } else {
            DoIdle(hwnd);
        }
    }
    return msg.wParam;
}
